library("lavaan")
data=read.csv("~/Dropbox/Statistik/sem_studie/newSEM2/BollenEstim/data.csv")
model <- '
   # latent variables
     ind60 =~ x1 + x2 + x3
     dem60 =~ y1 + y2 + y3 + y4
     dem65 =~ y5 + y6 + y7 + y8
   # regressions
     dem60 ~ ind60
     dem65 ~ ind60 + dem60
'
print("ML ============================ ")
fit <- sem(model,data=data)
summary(fit,standardized=TRUE,fit.measures=TRUE)
print(" ============================ ")
PM=function(fit) {  
  t=coef(fit)
  return(paste("Bollencoeffs={", 
                 toString(t[["dem60~ind60"]]), ",", # b1
                 toString(t[["dem65~ind60"]]), ",", # b2
                 toString(t[["dem65~dem60"]]), ",", # b3
                 toString(t[["ind60=~x2"]]), ",", # c2
                 toString(t[["ind60=~x3"]]), ",", # c3
                 toString(t[["dem60=~y2"]]), ",", # d2
                 toString(t[["dem60=~y3"]]), ",", # d3
                 toString(t[["dem60=~y4"]]), ",", # d4
                 toString(t[["dem65=~y6"]]), ",", # d6
                 toString(t[["dem65=~y7"]]), ",", # d7
                 toString(t[["dem65=~y8"]]), "};" # d8
  ) ) }

print(PM(fit))
LLs=lavPredict(fit)
ll="llR={"
for(j in 1:ncol(LLs)){
  ll=paste(ll,"{",sep="")
  for(i in 1:nrow(LLs)){
     ll=paste(ll,toString(LLs[i,j]),sep="")
     if(i<nrow(LLs)) {ll=paste(ll,", ",sep="")}
  }
  if(j<ncol(LLs)) {ll=paste(ll,"}, ",sep="")} else {ll=paste(ll,"}",sep="")}
}  
ll=paste(ll,"};",sep="")
print(ll)
n=nrow(LLs)


fileConn<-file("~/Dropbox/Statistik/sem_studie/newSEM2/BollenEstim/result.m")
writeLines(c(PM(fit),ll), fileConn)
close(fileConn)
